Module RuntimeAssertion
    ' If the assertion is False, display a message and a stack trace.
    Public Sub ReleaseAssert(ByVal assertion As Boolean, Optional ByVal message As String = "Assertion Failed")
        If Not assertion Then
            ' Get a stack trace.
            Dim stack_trace As New StackTrace(1, True)

            ' Log the message appropriately
            My.Application.Log.WriteEntry( _
                vbCrLf & Now & vbCrLf & _
                message & vbCrLf & _
                stack_trace.ToString() & _
                "**********" & vbCrLf)

            ' Add a prompt and the stack trace.
            message &= vbCrLf & vbCrLf & "Do you want to try to continue running anyway?"
            message &= vbCrLf & vbCrLf & stack_trace.ToString()

            ' Display the message.
            If MessageBox.Show( _
                message, _
                "Failed Assertion", _
                MessageBoxButtons.YesNo, _
                MessageBoxIcon.Exclamation) = DialogResult.No _
            Then
                End
            End If
        End If
    End Sub
End Module
